/*
**      syblogin.h   34.1    5/10/88
**
**    LOGINREC.H
**
**      Include file for use by the login code.
**
**
**
**    History:
**      Written 11/20/85 (cfr)
**
**
**
**      Sybase DB-LIBRARY Version 2.0
**      Confidential Property of Sybase, Inc.
**      (c) Copyright Sybase, Inc. 1985, 1986
**      All rights reserved
*/
typedef struct loginrec
{
        BYTE    lhostname[MAXNAME];     /* name of host or generic */
        BYTE    lhostnlen;              /* length of lhostname */
        BYTE    lusername[MAXNAME];     /* name of user */
        BYTE    lusernlen;              /* length of lusername */
        BYTE    lpw[MAXNAME];           /* password (plaintext) */
        BYTE    lpwnlen;                /* length of lpw */
        BYTE    lhostproc[MAXNAME];     /* host process identification*/
        BYTE    lhplen;                 /* length of host process id */
        BYTE    lint2;                  /* type of int2 on this host */
        BYTE    lint4;                  /* type of int4 on this host */
        BYTE    lchar;                  /* type of char */
        BYTE    lflt;                   /* type of float */
        BYTE    ldate;                  /* type of datetime */
        BYTE    lusedb;                 /* notify on exec of use db cmd */
        BYTE    ldmpld;                 /* disallow use of dump/load and
                                        ** bulk insert */
        BYTE    linterface;             /* interface type - SQL, TI,etc. */
        BYTE    spare[8];               /* spare fields */
        BYTE    lappname[MAXNAME];      /* name of application */
        BYTE    lappnlen;               /* length of lappname */
        BYTE    dummy_1;                /* filler to make structure size even */
} LOGINREC;

/* possible storage types */
# define INT4_LSB_HI    0       /* lsb is hi byte (eg 68000) */
# define INT4_LSB_LO    1       /* lsb is low byte (eg VAX & 80x86) */
# define INT2_LSB_HI    2       /* lsb is hi byte (eg 68000) */
# define INT2_LSB_LO    3       /* lsb is low byte (eg VAX & 80x86) */
# define FLT_IEEE_HI    4       /* IEEE 754 float, lsb in high byte (eg Sun) */
# define FLT_IEEE_LO    10      /* IEEE 754 float, lsb in low byte (eg 80x86) */
# define FLT_VAXD       5       /* VAX 'D' floating point format */
# define CHAR_ASCII     6       /* ASCII character set */
# define CHAR_EBCDIC    7       /* EBCDIC character set */
# define TWO_I4_LSB_HI  8       /* lsb is hi byte (eg 68000) */
# define TWO_I4_LSB_LO  9       /* lsb is low byte (eg VAX & 80x86) */

/* values for Sun isql 
**      lint2 = INT2_LSB_HI
**      lint4 = INT4_LSB_HI
**      lchar = CHAR_ASCII
**      lflt = FLT_IEEE_HI
**      ldate = TWO_I4_LSB_HI 
*/

/* values for VAX isql 
**      lint2 = INT2_LSB_LO
**      lint4 = INT4_LSB_LO
**      lchar = CHAR_ASCII
**      lflt = FLT_VAXD
**      ldate = TWO_I4_LSB_LO 
*/

/* values for 80x86 isql 
**      lint2 = INT2_LSB_LO
**      lint4 = INT4_LSB_LO
**      lchar = CHAR_ASCII
**      lflt = FLT_IEEE_LO
**      ldate = TWO_I4_LSB_LO 
*/
